"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ScheduledTaskManager = void 0;
const typedi_1 = require("typedi");
const cron_1 = require("cron");
let ScheduledTaskManager = class ScheduledTaskManager {
    constructor() {
        this.cronJobs = new Map();
    }
    registerCron(workflow, cronExpression, onTick) {
        const cronJob = new cron_1.CronJob(cronExpression, onTick, undefined, true, workflow.timezone);
        const cronJobsForWorkflow = this.cronJobs.get(workflow.id);
        if (cronJobsForWorkflow) {
            cronJobsForWorkflow.push(cronJob);
        }
        else {
            this.cronJobs.set(workflow.id, [cronJob]);
        }
    }
    deregisterCrons(workflowId) {
        var _a;
        const cronJobs = (_a = this.cronJobs.get(workflowId)) !== null && _a !== void 0 ? _a : [];
        for (const cronJob of cronJobs) {
            cronJob.stop();
        }
    }
    deregisterAllCrons() {
        for (const workflowId of Object.keys(this.cronJobs)) {
            this.deregisterCrons(workflowId);
        }
    }
};
exports.ScheduledTaskManager = ScheduledTaskManager;
exports.ScheduledTaskManager = ScheduledTaskManager = __decorate([
    (0, typedi_1.Service)()
], ScheduledTaskManager);
//# sourceMappingURL=ScheduledTaskManager.js.map